#!/usr/bin/env python3

import logging
import re
import requests
import sys

# Get public ip and update dns record in he.net

def get_public_ip():
    GEOIP ="http://geoip.ubuntu.com/lookup"
    r = requests.get(GEOIP)
    pattern = re.compile("<Ip>([^<]*)</Ip>")
    matches = pattern.findall(r.text)
    return matches[0] if matches else ""

def post_local_ip(pub_ip, hostname):
    # |KEY| is generated in dns.he.net control panel.
    # All of subdomain share the same |KEY|, in order to
    # make things easier.
    KEY = "YOUR_DDNS_KEY"
    url = "https://dyn.dns.he.net/nic/update"
    data = {
        "hostname": hostname,
        "password": KEY,
        "myip": pub_ip,
    }
    requests.post(url, data)

def main():
    logging.basicConfig(format="%(asctime)s %(message)s")
    pub_ip = get_public_ip()
    if pub_ip:
        logging.warning("Public ip: %s" % pub_ip)
        hostnames = (
            "sub1.example.com"
            "sub2.example.com",
        )
        for hostname in hostnames:
            post_local_ip(pub_ip, hostname)
    else:
        sys.exit(1)


if __name__ == "__main__":
    main()
